<template>
  <b-container
    id="f-page"
    tag="main"
  >
    <section>
      <h1 class="text-center">
        <span v-html="$t('newsletter.title')"></span>
      </h1>
      <b-row align-h="center">
        <b-col
          lg="8"
          xl="9"
        >
          <div v-html="$t('newsletter.intro')"></div>

          <div class="clearfix mb-2">
            <b-form
              method="post"
              name="subscribeform"
              action="https://listmonk.framasoft.org/subscription/form"
              class="col-md-10 fb-g4 mx-auto my-4 px-4 py-3 rounded"
            >
              <b-input-group class="mb-3">
                <b-input-group-prepend>
                  <!-- Only decorative-->
                  <b-button
                    aria-hidden="true"
                    class="disabled"
                  >
                    <i class="far fa-envelope fc-g1 fa-fw"></i>
                  </b-button>
                  <label
                    class="sr-only"
                    for="nl-email"
                    v-html="$t('newsletter.your-email')"
                  ></label>
                </b-input-group-prepend>
                <b-form-input
                  id="nl-email"
                  v-model="email"
                  name="email"
                  type="email"
                  size="40"
                  :title="$t('newsletter.type-your-email')"
                  :placeholder="$t('newsletter.your-email')"
                />
              </b-input-group>
              <div class="text-right">
                <!-- <Unsubscribe :email="email" /> -->
                <b-button
                  variant="primary"
                  name="subscribe"
                  type="submit"
                  value="subscribe"
                >
                  <i class="fas fa-bell fc-f1"></i>
                  <span v-html="$t('newsletter.subscribe')"></span>
                </b-button>
              </div>
              <div style="display: none">
                <input
                  id="c9c93"
                  checked
                  name="l"
                  type="checkbox"
                  value="c9c93baf-1117-44f4-9e32-a37ed4a97f58"
                />
              </div>
            </b-form>
          </div>
          <p v-html="$t('newsletter.nb')"></p>
        </b-col>
      </b-row>
    </section>

    <section id="archives">
      <b-row>
        <b-col>
          <h2 v-html="$t('newsletter.archives')"></h2>
        </b-col>
      </b-row>
      <b-row>
        <b-col
          v-for="year in years"
          :key="year"
          lg="6"
          class="mb-4"
        >
          <h3 v-html="year"></h3>
          <b-card
            no-body
            mig-top
          >
            <img
              alt=""
              class="card-img"
              :src="`${$t('baseurl')}img/nl/${year}.jpg`"
            />
            <b-card-body>
              <b-card-text>
                <b-list-group>
                  <b-list-group-item
                    v-for="k in nl[year].nl"
                    :key="k"
                    :to="`?nl=${$t(`newsletter.posts.${k}.id`)}`"
                    @click.prevent="
                      active = k;
                      $refs.nl.$el.scrollIntoView({ behavior: 'smooth' })"
                  >
                    <span
                      v-html="`N°${$t(`newsletter.posts.${k}.id`)} - ${
                        (new Date(`20${k}`))
                          .toLocaleDateString($t('lang'), {
                            month: 'long'
                          })}`"
                    ></span>
                  </b-list-group-item>
                </b-list-group>
                <div
                  v-if="nl[year].hs.length > 0"
                  class="mt-2"
                >
                  <b-list-group>
                    <b-list-group-item
                      v-for="k in nl[year].hs"
                      :key="k"
                      :to="`?nl=${$t(`newsletter.posts.${k}.id`)}`"
                      @click.prevent="
                        active = k;
                        $refs.nl.$el.scrollIntoView({ behavior: 'smooth' })"
                    >
                      <span
                        v-html="`${$t('newsletter.hs')
                        } n°${$t(`newsletter.posts.${k}.id`).replace('hs', '')} - ${
                          (new Date(`20${k}`))
                            .toLocaleDateString($t('lang'), {
                              month: 'long'
                            })}`"
                      ></span>
                    </b-list-group-item>
                  </b-list-group>
                </div>
              </b-card-text>
            </b-card-body>
          </b-card>
        </b-col>
      </b-row>
    </section>

    <section
      v-if="$t('lang') === 'fr'"
      id="listmonk"
      aria-hidden="true"
      class="pt-4 fb-g3"
    >
      <div
        v-html="style"
      ></div>
      <b-container
        v-show="/frama\.io/.test($t('host'))"
        class="px-sm-0 text-right"
      >
        <b-form-textarea
          id="nl-code"
          ref="nl-code"
          v-model="md"
          class="sr-only"
          readonly
          rows="10"
          style="width: 1px;height: 1px;"
        />
        <a
          :href="`https://framagit.org/framasoft/contact/-/wikis/newsletter/${$t(`newsletter.posts.${active}.id`)}`"
          class="btn btn-outline-primary"
        >
          <i class="fas fa-pencil"></i>
          Modifier
        </a>
        <a
          href="https://framagit.org/framasoft/contact/-/wikis/newsletter/00"
          class="btn btn-outline-primary"
        >
          <i class="fas fa-plus"></i>
          Ajouter une newsletter
        </a>
        <a
          :href="`https://framagit.org/${$t('host').replace('.frama.io', '')}/contact/-/pipelines`"
          title="Actualiser cette preview"
          class="btn btn-outline-primary"
        >
          <i class="fas fa-rotate"></i>
          <span class="sr-only">Preview</span>
        </a>
        <a
          href="https://framagit.org/framasoft/contact/-/pipelines"
          title="Mettre en production"
          class="btn btn-outline-primary"
        >
          <i class="fas fa-rocket"></i>
          <span class="sr-only">Prod</span>
        </a>
        <b-button
          variant="primary"
          @click.prevent.stop="copyMd()"
        >
          <i class="fas fa-copy"></i>
          Copier la source markdown
        </b-button>
      </b-container>
    </section>

    <nl
      v-show="$te(`newsletter.posts.${active}`)"
      ref="nl"
      :post="`${active}`"
    />

    <div
      v-show="copied"
      class="alert alert-success position-fixed fixed-top m-4 ml-auto"
      aria-hidden="true"
      style="z-index: 2000; width: 200px"
    >
      Markdown copié&nbsp;!
    </div>
  </b-container>
</template>

<script>
import Nl from './newsletter/Nl.vue';
// import Unsubscribe from '../components/Unsubscribe.vue';

export default {
  components: {
    Nl,
    // Unsubscribe,
  },

  metaInfo() {
    const meta = this.$t('lang') === 'fr'
      ? {
        link: [
          {
            rel: 'alternate',
            type: 'application/rss+xml',
            title: this.$t('newsletter.title'),
            href: `${this.$t('baseurl')}${
              this.$route.path.replace(/^\//, '').replace(/\/?$/, '/')}feed.xml`,
          },
        ],
      }
      : {};
    return meta;
  },

  data() {
    const nl = {};
    let active = '01-01-01';
    Object.keys(this.$t('newsletter.posts')).forEach((k) => {
      const y = `20${k.substr(0, 2)}`;
      if (!nl[y]) {
        nl[y] = {
          nl: [],
          hs: [],
        };
      }
      if (/^hs/.test(this.$t(`newsletter.posts.${k}.id`))) {
        nl[y].hs.unshift(k);
      } else {
        nl[y].nl.unshift(k);
      }
      if (new Date(`20${k}`) > new Date(`20${active}`)) {
        active = k;
      }
    });

    return {
      active,
      copied: false,
      email: '',
      nl,
      html: '',
      md: '',
      style: '',
      years: Object.keys(nl).reverse(),
    };
  },

  mounted() {
    const q = Object.fromEntries(new URLSearchParams(window.location.search).entries());
    if (q.nl !== undefined) {
      Object.keys(this.$t('newsletter.posts')).forEach((k) => {
        if (this.$t(`newsletter.posts.${k}.id`) === q.nl) {
          this.active = k;
        }
      });
      this.$nextTick(() => {
        this.$refs.nl.$el.scrollIntoView();
      });
    } else {
      [this.active] = [Object.keys(this.$t('newsletter.posts'))
        .filter(k => !/^hs/.test(this.$t(`newsletter.posts.${k}.id`)))
        .reverse()[0]];
    }

    this.html = `<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta name="viewport" content="width=device-width,initial-scale=1">
  <meta name="author" content="Framasoft" />
  <title>Lettre d’information Framasoft #${this.$t(`newsletter.posts.${this.active}.id`)}</title>
  ${this.style}
</head>
<body id="nl">
${this.$refs.nl.$el.innerHTML}
</body>
</html>`;

    const html = document.createElement('div');
    html.innerHTML = this.$t(`newsletter.posts.${this.active}.text`);
    const headings = html.getElementsByTagName('*');
    let toc = '<div id="toc">\n\n## Sommaire\n';

    for (let i = 0; i < headings.length; i += 1) {
      let id = headings[i].id.replace(/[^a-zA-Z0-9-]/gi, '').toLowerCase();
      if (headings[i].tagName === 'H1') {
        if (headings[i].children.length > 0
          && headings[i].children[0].tagName === 'IMG') {
          id += headings[i].children[0].getAttribute('src')
            .replace(/^.+\/wiki/, `${this.$t('link.contact')}/wiki/`)
            .replace(/[^a-zA-Z0-9-]/gi, '').toLowerCase();
          toc += `- [${headings[i].children[0].getAttribute('alt')}](#${id})\n`;
        } else {
          toc += `- [${headings[i].innerText}](#${id})\n`;
        }
      }
      if (headings[i].tagName === 'H2') {
        toc += `  - [${headings[i].innerText}](#${id})\n`;
      }
    }
    toc += '\n</div>\n';

    fetch(`${this.$t('baseurl')}/wiki/newsletter/${this.$t(`newsletter.posts.${this.active}.id`)}.md`)
      .then(res => res.text())
      .then((data) => {
        this.md = data
          // Replace wiki relative links by local links
          .replace(/\]\(uploads\//gm, `](${this.$t('link.contact')}/wiki/`)
          // Remove front matter
          .replace(`\`\`\`${data.split('```')[1]}\`\`\``, '')
          .replace('# ', `${toc}\n# `);
        if (this.$t(`newsletter.posts.${this.active}.img`) !== '') {
          this.md = [
            '# ![',
            this.$t(`newsletter.posts.${this.active}.title`),
            '](',
            this.$t(`newsletter.posts.${this.active}.img`)
              .replace(/^uploads\//, `${this.$t('link.contact')}/wiki/`),
            ')\n',
            this.md,
          ].join('');
        }
      })
      .catch(err => console.error(err)); // eslint-disable-line
  },

  methods: {
    copyMd() {
      const textarea = this.$refs['nl-code'];
      textarea.select();
      document.execCommand('copy');
      this.copied = true;
      setTimeout(() => { this.copied = false; }, 2000);
    },
  },
};
</script>

<style lang="scss">
#newsletter {
  .card-img {
    border-bottom-right-radius: 0;
    border-bottom-left-radius: 0;
  }

  #nl {
    padding-top: 1rem;

    h2::after {
      content: none;
    }

    a:not(.btn-soutenir) {
      background: none;
    }
  }

  .mt-sm-n4.pr-sm-0 {
    display: none;
  }
}
</style>
